#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
--PKG = mini-cipa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: minicipa.pgoblin.m4,v 1.11 2019/08/19 19:12:12 babolo Exp $

#connect 0001
sqlite2
#perform 0001
CREATE TEMP TABLE a(i int, a text);
#getarg  1
#copyin  0011
COPY a FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE e(i int, n text, e text);
#getenv  1
#copyin  0011
COPY e FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE x(b text, u text);
#perform 0001
INSERT INTO x
 SELECT COALESCE( (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
                , 'minicipa'
                )
      , (SELECT e FROM e WHERE n = 'USER' AND regexp('^[a-z0-9_]+$', e))
;
#connect 000T
pgsql dbname=template1 requirepeer=postgres application_name=minicipa
#select  G001
SELECT 'CREATE DATABASE ' || b || ';' FROM x;
#select  J001
SELECT 'CREATE ROLE ' || b || ' WITH LOGIN;' FROM x;
#select  1001
SELECT 'CREATE ROLE ' || u || ' WITH LOGIN;' FROM x;
#trap
#echo
@@@Ignore it

#return
#perform 000T
CREATE ROLE root WITH LOGIN;
#perform 000T
CREATE ROLE operator WITH NOLOGIN;
#perform 0G0T
#perform 0J0T
#perform 010T
#untrap
#select  1001
SELECT 'pgsql dbname=' || b || ' requirepeer=postgres application_name=minicipa'
 FROM x
;
#connect 0102
#close   101
#close   G0G
#close   J0J
#select  1001
SELECT 'GRANT ALL ON DATABASE ' || b || ' TO ' || b || ';' FROM x;
#perform 0102
#select  1001
SELECT 'GRANT CONNECT, TEMP ON DATABASE ' || b || ' TO root, operator;' FROM x;
#perform 0102
#perform 0002
CREATE EXTENSION IF NOT EXISTS babolo_pglib;
#perform 0002
ALTER EXTENSION babolo_pglib UPDATE;
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.cipares_q MINVALUE 0;
#close   101
#trap
#select  1001
SELECT 'SELECT bitex1('',MAX(r)) FROM (SELECT MAX(length(resource)) AS r FROM cipalan UNION SELECT MAX(cipares) FROM cipares)n;
'
;
#return
#perform 0002
SELECT 1 FROM public.cipamask;
#untrap
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipares
     ( cipares    int4     PRIMARY KEY DEFAULT nextval('public.cipares_q')
     , ciparesnm  text     NOT NULL UNIQUE
     )
;
#perform 0002
ALTER TABLE public.cipares ADD UNIQUE(ciparesnm);
#perform 0002
COMMENT ON TABLE public.cipares          IS '  ';
COMMENT ON COLUMN public.cipares.cipares    IS ' ';
COMMENT ON COLUMN public.cipares.ciparesnm  IS ' ';
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.cipalevel_q MINVALUE 0;
#close   101
#trap                ----------------------------------------------------------------------------------
#select  1001        --  TABLE cipamask ,     ţ
SELECT '
INSERT INTO public.cipamask
 SELECT 0, public.bitex1('''', MAX(r))
  FROM(SELECT MAX(length(resource)) AS r FROM public.cipalan
      UNION
       SELECT MAX(cipares) FROM public.cipares
      )n
;
'
;
#return
#perform 0002
SELECT 1 FROM public.cipamask;
#untrap
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipamask
     ( cipalevel int4      PRIMARY KEY DEFAULT nextval('public.cipalevel_q')
     , cipamask  varbit    NOT NULL
     )
;
#perform 0102        --  TABLE cipamask,  
#perform 0002        ----------------------------------------------------------------------------------
COMMENT ON TABLE public.cipamask         IS '';
COMMENT ON COLUMN public.cipamask.cipalevel IS '';
COMMENT ON COLUMN public.cipamask.cipamask  IS '';
#perform 0002
SELECT setval('public.cipalevel_q', MAX(cipamask.cipalevel)) FROM public.cipamask;
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.cipalan_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipalan
     ( cipalan   int4      PRIMARY KEY DEFAULT nextval('public.cipalan_q')
     , cipath    text[]    NOT NULL
     , selflock  int4
     , whom      text      NOT NULL
     , period    interval
     , strict    bool      NOT NULL DEFAULT FALSE
     , selfgr    bool      NOT NULL DEFAULT FALSE
     , success   bool      NOT NULL DEFAULT TRUE
     , resource  bytea     NOT NULL
     , resar     int4[]
     , renul     text[]
     )
;
#perform 0002
ALTER TABLE public.cipalan ADD IF NOT EXISTS resar int4[];
#perform 0002
ALTER TABLE public.cipalan ADD IF NOT EXISTS renul text[];
#perform 0002
COMMENT ON TABLE public.cipalan          IS '  ';
COMMENT ON COLUMN public.cipalan.cipalan    IS ' ';
COMMENT ON COLUMN public.cipalan.cipath     IS 'PATH  +  ';
COMMENT ON COLUMN public.cipalan.selflock   IS '  (NULL , 0 -   , ...)';
COMMENT ON COLUMN public.cipalan.whom       IS 'uname,   ';
COMMENT ON COLUMN public.cipalan.period     IS ' ';
COMMENT ON COLUMN public.cipalan.strict     IS '     ';
COMMENT ON COLUMN public.cipalan.selfgr     IS '  ';
COMMENT ON COLUMN public.cipalan.success    IS '  ';
COMMENT ON COLUMN public.cipalan.resource   IS '   ';
COMMENT ON COLUMN public.cipalan.resar      IS '    ';
COMMENT ON COLUMN public.cipalan.renul      IS '   ,   resar';
#perform 0002
SELECT setval('public.cipalan_q', MAX(cipalan.cipalan)) FROM public.cipalan;
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.cipaxn_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipaon
     ( cipaon    int8      PRIMARY KEY DEFAULT nextval('public.cipaxn_q')
     , cipalan   int4      REFERENCES cipalan 
     , ciparg    text[]
     , plan      timestamp NOT NULL
     , deed      timestamp
     , pid       int4
     , reed      timestamp NOT NULL DEFAULT now()
     , try       int4      NOT NULL DEFAULT 0
     )
;
#perform 0002
COMMENT ON TABLE public.cipaon           IS ' ';
COMMENT ON COLUMN public.cipaon.cipaon      IS '  ';
COMMENT ON COLUMN public.cipaon.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipaon.ciparg      IS ' ';
COMMENT ON COLUMN public.cipaon.pid         IS 'PID ';
COMMENT ON COLUMN public.cipaon.plan        IS '  ';
COMMENT ON COLUMN public.cipaon.deed        IS '  ';
COMMENT ON COLUMN public.cipaon.reed        IS '  ';
COMMENT ON COLUMN public.cipaon.try         IS '  ';
#perform 0002
ALTER TABLE IF EXISTS ONLY public.cipaon ALTER deed DROP NOT NULL;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipain
     ( cipain    int8      PRIMARY KEY DEFAULT nextval('public.cipaxn_q')
     , cipaher   int8      REFERENCES cipaon
     , cipalan   int4      REFERENCES cipalan
     , waitout   int8[]
     , ciparg    text[]
     , plan      timestamp NOT NULL DEFAULT now()
     , prio      int2      NOT NULL DEFAULT 1000
     , deed      timestamp
     , pid       int4
     , try       int4      NOT NULL DEFAULT 0
     , ghost     bool      NOT NULL DEFAULT FALSE
     )
;
#perform 0002
ALTER TABLE public.cipain ADD IF NOT EXISTS ghost bool NOT NULL DEFAULT FALSE;
#perform 0002
COMMENT ON TABLE public.cipain           IS '  ';
COMMENT ON COLUMN public.cipain.cipain      IS '  ';
COMMENT ON COLUMN public.cipain.cipaher     IS '  ';
COMMENT ON COLUMN public.cipain.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipain.waitout     IS '    cipaon.cipaon';
COMMENT ON COLUMN public.cipain.ciparg      IS ' ';
COMMENT ON COLUMN public.cipain.plan        IS '  ';
COMMENT ON COLUMN public.cipain.prio        IS '';
COMMENT ON COLUMN public.cipain.deed        IS '  ';
COMMENT ON COLUMN public.cipain.pid         IS 'PID ';
COMMENT ON COLUMN public.cipain.try         IS '  ';
COMMENT ON COLUMN public.cipain.ghost       IS ' ,  ';
#perform 0002
CREATE INDEX IF NOT EXISTS cipain_t ON public.cipain(plan);
#perform 0002
CREATE INDEX IF NOT EXISTS cipain_h ON public.cipain(cipaher);
#perform 0002
SELECT setval('public.cipaxn_q', MAX(m.m))
 FROM (SELECT MAX(cipain.cipain) AS m FROM public.cipain
      UNION
       SELECT MAX(cipaon.cipaon) AS m FROM public.cipaon
      )m
;
#perform 0002
CREATE OR REPLACE VIEW public.cipaxn AS
 WITH z AS(SELECT cipain, row_number() OVER (PARTITION BY cipain) AS cipalevel, arg
            FROM(SELECT cipain
                      , COALESCE((a.cipath || cipain.ciparg)[anum], a.aval) AS arg
                  FROM  (SELECT cipalan, cipath, unnest(resar) AS anum, unnest(renul) AS aval
                          FROM public.cipalan
                        )a
                   JOIN public.cipain USING(cipalan)
                )b
            WHERE arg IS NOT NULL
          UNION
           SELECT cipain, 0, NULL::text FROM public.cipain
          ORDER BY cipain, cipalevel, arg
         )
  SELECT cipain.cipain
       , cipain.cipaher
       , cipain.cipalan
       , cipain.waitout
       , cipain.ciparg
       , cipain.plan
       , cipain.prio
       , cipain.try
       , (   cipain.pid IS NULL
         AND NOT EXISTS(SELECT 1
                         FROM unnest(cipain.waitout)h LEFT JOIN public.cipaon ON(h = cipaon.cipaon)
                         WHERE cipaon.cipaon IS NULL
                       )
         AND NOT EXISTS(SELECT 1
                         FROM public.cipain c JOIN public.cipalan b USING(cipalan)
                         WHERE public.compare( cipalan.selflock
                                             , cipalan.cipath || cipain.ciparg
                                             , b.cipath || c.ciparg
                                             )
                           AND c.pid IS NOT NULL
                       )
         AND public.bytearrmax(public.bytearradd(cipalan.resource, COALESCE(s.resum, '\x'))) < 255
         ) AS ready
   FROM       public.cipain
         JOIN public.cipalan USING(cipalan)
    LEFT JOIN (SELECT cipain, public.bytearrsum(resum) AS resum
                FROM z
                 LEFT JOIN(SELECT cipalevel
                                , arg
                                , public.bytearrsum(public.bytearrmask( cipalan.resource
                                                                      , cipamask.cipamask
                                                   )                  ) AS resum
                            FROM public.cipamask
                             JOIN z USING(cipalevel)
                             JOIN public.cipain  USING(cipain)
                             JOIN public.cipalan USING(cipalan)
                            WHERE cipain.pid IS NOT NULL
                           GROUP BY arg, cipalevel
                          )c USING(cipalevel, arg)
               GROUP BY cipain
              )s USING(cipain)
   WHERE NOT ghost
;
#perform 0002
COMMENT ON VIEW public.cipaxn            IS '  ';
COMMENT ON COLUMN public.cipaxn.cipain      IS '  ';
COMMENT ON COLUMN public.cipaxn.cipaher     IS '    period';
COMMENT ON COLUMN public.cipaxn.cipalan     IS '  public.cipalan';
COMMENT ON COLUMN public.cipaxn.waitout     IS '    cipaon.cipaon';
COMMENT ON COLUMN public.cipaxn.ciparg      IS ' ';
COMMENT ON COLUMN public.cipaxn.plan        IS '  ';
COMMENT ON COLUMN public.cipaxn.prio        IS '';
COMMENT ON COLUMN public.cipaxn.try         IS '  ';
COMMENT ON COLUMN public.cipaxn.ready       IS '   ';
#perform 0002
CREATE OR REPLACE RULE cipadn AS
    ON DELETE TO public.cipain
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipain AS
    ON INSERT TO public.cipain
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipaun AS
    ON UPDATE TO public.cipain
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipadl AS
    ON DELETE TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
# perform 0002
CREATE OR REPLACE RULE cipail AS
    ON INSERT TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipaul AS
    ON UPDATE TO public.cipalan
    DO ALSO NOTIFY "cipaxn"
;
#perform 0002
CREATE OR REPLACE RULE cipaon AS
    ON DELETE TO public.cipaxn
    DO INSTEAD
    ( INSERT INTO public.cipaon(cipaon, cipalan, ciparg, pid, plan, deed, try)
       SELECT cipain.cipain
            , cipain.cipalan
            , cipain.ciparg
            , cipain.pid
            , cipain.plan
            , cipain.deed
            , cipain.try
        FROM public.cipain
        WHERE cipain.cipain IN(SELECT d.cipain
                                FROM  public.cipain d
                                 JOIN public.cipain i USING(cipalan)
                                 JOIN public.cipalan USING(cipalan)
                                WHERE (d.waitout, d.ciparg) IS NOT DISTINCT FROM (i.waitout, i.ciparg)
                                  AND i.cipain = OLD.cipain
                                  AND cipalan.selfgr
                                  AND i.plan < now()
                              UNION
                               SELECT OLD.cipain
                              )
    ;
      INSERT INTO public.cipain(cipaher, cipalan, ciparg, plan, waitout, prio)
       SELECT i.cipain
            , i.cipalan
            , i.ciparg
            , CASE WHEN cipalan.strict THEN i.plan ELSE COALESCE(i.deed, now()) END + cipalan.period
            , (SELECT array_agg(cipain.cipain)
                FROM public.cipain, unnest(i.waitout)u
                WHERE cipain.cipaher = u
              )
            , i.prio
        FROM public.cipalan JOIN public.cipain i USING(cipalan)
        WHERE i.cipain = OLD.cipain
          AND cipalan.period IS NOT NULL
    ;
      DELETE FROM public.cipain
       WHERE cipain.cipain IN(SELECT d.cipain
                                FROM public.cipain d
                                 JOIN public.cipain i USING(cipalan)
                                 JOIN public.cipalan USING(cipalan)
                                WHERE (d.waitout, d.ciparg) IS NOT DISTINCT FROM (i.waitout, i.ciparg)
                                  AND i.cipain = OLD.cipain
                                  AND cipalan.selfgr
                                  AND i.plan < now()
                              UNION
                               SELECT OLD.cipain
                              EXCEPT
                               SELECT d.cipain FROM public.cipain d WHERE d.cipaher = OLD.cipain
                              )
       RETURNING cipain.cipain
               , cipain.cipaher
               , cipain.cipalan
               , cipain.waitout
               , cipain.ciparg
               , cipain.plan
               , cipain.prio
               , cipain.try
               , FALSE
 )
;
#perform 0002
CREATE OR REPLACE RULE cipaan AS
    ON INSERT TO public.cipaxn
    DO INSTEAD
    ( INSERT INTO public.cipain(cipaher, cipalan, waitout, ciparg, plan, prio)
       SELECT NEW.cipaher
            , NEW.cipalan
            , NEW.waitout
            , NEW.ciparg
            , COALESCE(NEW.plan, now())
            , COALESCE(NEW.prio, 1000)
        FROM public.cipalan
        WHERE cipalan.cipalan = NEW.cipalan
      RETURNING cipain.cipain
              , cipain.cipaher
              , cipain.cipalan
              , cipain.waitout
              , cipain.ciparg
              , cipain.plan
              , cipain.prio
              , cipain.try
              , NULL::bool
    )
;
#select  1001
SELECT 'GRANT SELECT ON public.cipares_q
                      , public.cipares
                      , public.cipalan_q
                      , public.cipalan
                      , public.cipaon
                      , public.cipain
                      , public.cipaxn_q
                      , public.cipaxn
                      , public.cipamask
                      , public.cipalevel_q
                     TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT INSERT ON public.cipain
                      , public.cipaxn
                      , public.cipaon
                      , public.cipares
                     TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#select  1001
SELECT 'GRANT USAGE, UPDATE ON public.cipares_q, public.cipalan_q TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#perform 0002
GRANT INSERT ON public.cipalan TO operator;
#select  1001
SELECT 'GRANT UPDATE ON public.cipain, public.cipaxn_q TO operator, root, ' || b || '
;
'FROM x
;
#perform 0102
#perform 0002
GRANT DELETE ON public.cipaxn TO root;
